% Euler method :  E(t)
%    y1 = y0 + h*f(t0,y0) = y0 + v1,   v1 = f(t0,y0)
f = @(t,y) (1/4)*y.*(1-y/20);
sol = @(t) 20./( 1+19*exp(-t/4) );  % Exact sol
Y0 = 1;  % initial condition

h = input(' grid size h = '); 
t = 0:h:20; N = length(t);
Y = sol(t');  % Exact sol. 

E = zeros(N,1); E(1)=Y0;
for k=1:N-1
    v1=f(t(k),E(k));
    E(k+1) = E(k) + h*v1;
end
subplot(121); plot(t,Y,'b-',t,E,'m-'); title('Solution')
subplot(122); plot(t,Y-E,'m.-'); title('Error')