% RK2 method :  U(t)
%    v1 = f(t0,y0),  v2 = f(t0+h,y0+h*v1)
%    y1 = y0 + (h/2)*( v1+v2 )
f = @(t,y) (1/4)*y.*(1-y/20);
sol = @(t) 20./( 1+19*exp(-t/4) );  % Exact sol
Y0 = 1;  % initial condition

h = input(' grid size h = '); 
t = 0:h:20; N = length(t);
Y = sol(t');  % Exact sol.

U=zeros(N,1); U(1)=Y0;
for k=1:N-1
    v1=f(t(k),U(k));
    v2=f(t(k)+h,U(k)+h*v1);
    U(k+1)=U(k)+(h/2)*(v1+v2);
end
subplot(121); plot(t,Y,'b-',t,U,'m-'); title('Solution')
subplot(122); plot(t,Y-U,'m.-'); title('Error')