% Tayler method : T(t)
%    v1 = f(t0,y0), v2 = f_t(t0,y0),  v3 = f_y(t0,y0)
%    y1 = y0 + h*v1 + (h^2/2)*( v2 + v3*v1 )
f = @(t,y) (1/4)*y.*(1-y/20);
sol = @(t) 20./( 1+19*exp(-t/4) );  % Exact sol
Y0 = 1;  % initial condition

h = input(' grid size h = '); 
t = 0:h:20; N = length(t);
Y = sol(t');  % Exact sol. 

T=zeros(N,1); T(1)=Y0;
for k=1:N-1
    v1=f(t(k),T(k)); v2=0;
    v3=(1/4)*(1-(T(k)/10));
    T(k+1)=T(k)+h*v1+((h^2)/2)*(v2+v3*v1);
end
subplot(121); plot(t,Y,'b-',t,T,'m-'); title('Solution')
subplot(122); plot(t,Y-T,'m.-'); title('Error')